{
  Autor....: Daniel Pereira Guimares
  E-Mail...: tecnobyte@ulbrajp.com.br
  Home-Page: www.ulbrajp.com.br/usuarios/tecnobyte
  Fone/Fax.: 55-069-421-6756

  Veja dicas sobre Delphi em minha Home-Page.

  Este arquivo pode ser re-distribudo livremente,
  porm os dados acima devero ser preservados.

  Arquivos que fazem parte deste programa:
  ExtrIco.DPR, ExtrIco.RES, uExtrIco.PAS e uExtrIco.DFM.

  Programa desenvolvido em Delphi 4.
}

unit uExtrIco;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ShellApi, ExtCtrls, ComCtrls, ImgList, Dialogs;

type
  TForm1 = class(TForm)
    Button1: TButton;
    edtArq: TEdit;
    Label1: TLabel;
    btnProcurar: TButton;
    dlgOpen: TOpenDialog;
    edtDirSaida: TEdit;
    Label2: TLabel;
    edtPrefixo: TEdit;
    Label3: TLabel;
    barProg: TProgressBar;
    StatusBar1: TStatusBar;
    lblMail: TLabel;
    lblWeb: TLabel;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure btnProcurarClick(Sender: TObject);
    procedure lblMailClick(Sender: TObject);
    procedure lblWebClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
procedure TForm1.Button1Click(Sender: TObject);
var
  Qtd, I: integer;
  Icone: TIcon;
  DirSaida, Prefixo: string;
begin
  { Pega o diretrio de sada, colocando a
    barra (\) se estiver faltando }
  DirSaida := edtDirSaida.Text;
  if DirSaida[Length(DirSaida)] <> '\' then
    DirSaida := DirSaida + '\';
  edtDirSaida.Text := DirSaida;

  { Pega o prefixo para os nomes dos arquivos }
  Prefixo := edtPrefixo.Text;

  Qtd := ExtractIcon(0, PChar(edtArq.Text), $FFFFFFFF);
  if MessageDlg('Existem ' + IntToStr(Qtd) + ' cone(s). Deseja extra-los?',
       mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
   Exit;

  Application.ProcessMessages;

  barProg.Min := 0;
  barProg.Max := Qtd;
  barProg.Position := 0;

  Icone := TIcon.Create;
  try
    try
      for I := 0 to Qtd -1  do begin
        Icone.Handle := ExtractIcon(0, PChar(edtArq.Text), I);
        Icone.SaveToFile(
          Format('%s%s%s.ico', [DirSaida, Prefixo,
            FormatFloat('0000', I)]));
        barProg.Position := I +1;
      end;
    finally
      ShowMessage('Pronto.');
      barProg.Position := 0;
    end;
  finally
    Icone.Free;
  end;
end;

procedure TForm1.btnProcurarClick(Sender: TObject);
begin
  if dlgOpen.Execute then
    edtArq.Text := dlgOpen.FileName;
end;

procedure TForm1.lblMailClick(Sender: TObject);
begin
  ShellExecute(0, 'open',
    PChar('mailto:' + lblMail.Caption), nil, nil, 0);
end;

procedure TForm1.lblWebClick(Sender: TObject);
begin
  ShellExecute(0, 'open',
    PChar('http://' + lblWeb.Caption), nil, nil, 0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ShellExecute(0, 'open', 'explorer.exe',
    PChar(edtDirSaida.Text), nil, SW_MAXIMIZE);
end;

end.
